	.module ct04.c
	.area text
	.dbfile C:\projekte\msp430\ct04\ct04.c
	.dbfunc e vTask2 _vTask2 fV
;              i -> R4
;              w -> R5
	.even
_vTask2::
	push R4
	push R5
	.dbline -1
	.dbline 92
; /***************************************************************************
; * Titel        : CT04.C
; *
; * Description  : Einfaches Multitasking fr den MSP430
; *
; * Environment  :
; *
; * Responsible  : J. Altenburg
; *
; * Guidelines   :
; *
; * Revision List:
;   --------------------------------------------------------------------------
;   Date     | Author          | Change
;   --------------------------------------------------------------------------
;   13.01.04 |J. Altenburg     | Ersterstellung
;   --------------------------------------------------------------------------
;            |                 |
;   --------------------------------------------------------------------------
; ****************************************************************************/
; 
; /***************************************************************************
; * HEADER-FILES (Only those that are needed in this file)                   *
; ****************************************************************************/
; /* System-headerfiles */
; #include "cdef.h"                      /* General definitions and types */
; 
; #include "msp430x14x.h"
; #include "msp430def.h"
; 
; /* Own headerfiles */
; 
; 
; /* Foreign headerfiles */
; #include "uexec.h"
; 
; /***************************************************************************
; * Defines und Makros Zugriff                                               *
; ****************************************************************************/
; 
; /* Prototyp fr Funktionspointer */
; typedef void (* fLocalFunc)( void ); /* Funktionspointer */
; 
; 
; 
; /***************************************************************************
; *    Variablen                                                             *
; ****************************************************************************/
; struct stTimer{
;      word Run  : 1; /* Scheduling erlauben */
;      word F1   : 1; /* Timer-Flags, z.B. fr Zhlaufgaben */
;      } stTimer;
; 
; word wTaskId0; /*
; * Description : Task-ID
; */
; 
; word wTaskId1; /*
; * Description : Task-ID
; */
; 
; word wTaskId2;
; 
; word wRegister; /*
; * Description : Hilfsregister
; */
; 
; word w0;
; word w1;
; 
; byte bJA;
; 
; /***************************************************************************
; *   Stackbereiche fr Multitasking
; ****************************************************************************/
; byte abTask0[UEXC_MIN_STACK_SIZE]; /*
; * Description : Stackbereich fr Task 0
; */
; 
; byte abTask1[UEXC_MIN_STACK_SIZE]; /*
; * Description : Stackbereich fr Task 1
; */
; 
; 
; byte abTask2[UEXC_MIN_STACK_SIZE]; /*
; * Description : Stackbereich fr Task 1
; */
; 
; /***************************************************************************
; *    Beispieltasks
; ****************************************************************************/
; void vTask2( void ){
	.dbline 95
	mov.b #0,R4
	jmp L5
L2:
	.dbline 95
; 	 word w;
; 	 byte i;
; 	 for(i = 0; i < 8; i++){
	.dbline 96
; 	 	   w = 30000;
	mov #30000,R5
L6:
	.dbline 97
L7:
	.dbline 97
	mov R5,r13
	sub #1,R5
	cmp #0,r13
	jne L6
	.dbline 98
	xor.b #4,&0x29
	.dbline 99
L3:
	.dbline 95
	add.b #1,R4
L5:
	.dbline 95
	cmp.b #8,R4
	jlo L2
	.dbline -2
	.dbline 100
; 		   while(w--);
;            P2OUT ^= 0x04;	   /* Port P2.3 toggelt */
; 		   }
; 	 }
L1:
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r i 4 c
	.dbsym r w 5 i
	.dbend
	.dbfunc e vTask0 _vTask0 fV
;              w -> R4
	.even
_vTask0::
	push R4
	.dbline -1
	.dbline 102
; 
; void vTask0( void ){
	jmp L11
L10:
	.dbline 104
; 	 word w;
; 	 while(1){
	.dbline 105
; 	      w = 60000;
	mov #60000,R4
L13:
	.dbline 106
L14:
	.dbline 106
	mov R4,r13
	sub #1,R4
	cmp #0,r13
	jne L13
	.dbline 107
	xor.b #1,&0x29
	.dbline 108
L11:
	.dbline 104
	jmp L10
X0:
	.dbline -2
	.dbline 109
; 		  while(w--);
; 		  P2OUT ^= 0x01;	   /* Port P2.0 togglet */
; 		  }
;      }
L9:
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r w 4 i
	.dbend
	.dbfunc e vTask1 _vTask1 fV
;             dw -> 8(SP)
	.even
_vTask1::
	sub #12,R1
	.dbline -1
	.dbline 111
; 
; void vTask1( void ){
	jmp L18
L17:
	.dbline 113
; 	 dword dw;
; 	 while(1){
	.dbline 114
; 	      dw = 80000;
	mov #80000,8(R1)
	mov #1,10(R1)
L20:
	.dbline 115
L21:
	.dbline 115
	mov 10(R1),6(R1)
	mov 8(R1),4(R1)
	mov 4(R1),R12
	mov 6(R1),R13
	sub #1,R12
	subc #0,R13
	mov R12,8(R1)
	mov R13,10(R1)
	mov #0,R14
	mov #0,R15
	push 8(R1)
	push 8(R1)
	call #cmp32
	jne L20
	.dbline 116
	xor.b #2,&0x29
	.dbline 117
	mov #1,2(R1)
	mov #60,0(R1)
	mov #_abTask2,R15
	mov #_vTask2,R14
	call #_UEXC_CreateTask
	mov R14,r13
	mov r14,_wTaskId2
	.dbline 118
L18:
	.dbline 113
	jmp L17
X1:
	.dbline -2
	.dbline 119
; 		  while(dw--);
; 		  P2OUT ^= 0x02; 	   /* Port 2.1 togglet */
;           wTaskId2 = UEXC_CreateTask(vTask2, &abTask2[0], sizeof (abTask2), 1);	   
; 		  }
;      }
L16:
	add #12,R1
	.dbline 0 ; func end
	ret
	.dbsym l dw 8 l
	.dbend
	.dbfunc e vClockInit _vClockInit fV
;              w -> R4
	.even
_vClockInit::
	push R4
	.dbline -1
	.dbline 129
; 
; 
; 	   
; 
; /***************************************************************************
; *    Funktion: Hardware-Initialisierung (Application Builder)              *
; *                                                                          *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void vClockInit( void ){
	.dbline 132
;      word w;
;      // DCOCTL  = 0x00;
;      WDTCTL = WDTPW + WDTHOLD;     /* Watchdog deaktivieren */
	mov #23168,&0x120
	.dbline 134
; #if 1
;      P5DIR |= 0x10;                /* 8MHz-CLK am Pin 48 */
	or.b #16,&0x32
	.dbline 135
;      P5SEL |= 0x10;
	or.b #16,&0x33
	.dbline 136
;      P5DIR |= 0x20;                /* SMCLK an Pin 49 */
	or.b #32,&0x32
	.dbline 137
;      P5SEL |= 0x20;
	or.b #32,&0x33
	.dbline 139
; #endif
;      BCSCTL1 &= ~XT2OFF;           /* Oszillator on */
	and.b #-129,&0x57
L24:
	.dbline 140
;      do  {
	.dbline 141
;           IFG1 &= ~OFIFG;
	and.b #-3,&0x2
	.dbline 142
	mov #255,R4
	jmp L30
L27:
	.dbline 142
L28:
	.dbline 142
	sub #1,R4
L30:
	.dbline 142
;           for(w = 0xff; w > 0; w--);
	cmp #0,R4
	jne L27
	.dbline 143
;           }
L25:
	.dbline 144
;      while((IFG1 & OFIFG) != 0);
	bit.b #2,&0x2
	jne L24
	.dbline 145
;      BCSCTL2 = 0x88;
	mov.b #136,&0x58
	.dbline -2
	.dbline 147
; //     BCSCTL2 |= SELM1 + SELS + DIVS0;   /* nun los */
;      }
L23:
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r w 4 i
	.dbend
	.dbfunc e vPortInit _vPortInit fV
	.even
_vPortInit::
	.dbline -1
	.dbline 149
; 
; void vPortInit( void ){
	.dbline 150
;      P1OUT   = 0x00;               /* Schrittmotor 1 */
	mov.b #0,&0x21
	.dbline 151
;      P1DIR   = 0x7F;
	mov.b #127,&0x22
	.dbline 152
;      P1IES   = 0x00;
	mov.b #0,&0x24
	.dbline 153
;      P1IE    = 0x00;
	mov.b #0,&0x25
	.dbline 154
;      P1SEL   = 0x00;
	mov.b #0,&0x26
	.dbline 156
; 
;      P2OUT   = 0xFF;               /* LEDs */
	mov.b #255,&0x29
	.dbline 157
;      P2DIR   = 0xFF;
	mov.b #255,&0x2a
	.dbline 158
;      P2IES   = 0x00;
	mov.b #0,&0x2c
	.dbline 159
;      P2IE    = 0x00;
	mov.b #0,&0x2d
	.dbline 160
;      P2SEL   = 0x00;
	mov.b #0,&0x2e
	.dbline 162
; 
;      P3OUT   = 0x00;               /* UART0, P3.4 output */
	mov.b #0,&0x19
	.dbline 163
;      P3DIR   = 0x10;
	mov.b #16,&0x1a
	.dbline 164
;      P3SEL   = 0x30;
	mov.b #48,&0x1b
	.dbline 166
; 
;      P4OUT   = 0xFE;               /* CFG - Port */
	mov.b #254,&0x1d
	.dbline 167
;      P4DIR   = 0x7f;
	mov.b #127,&0x1e
	.dbline 168
;      P4SEL   = 0x00;
	mov.b #0,&0x1f
	.dbline 174
; #if 0
;      P5OUT   = 0x00;               /* not used */
;      P5DIR   = 0x00;
;      P5SEL   = 0x00;
; #endif
;      P6OUT   = 0x00;               /* not used */
	mov.b #0,&0x35
	.dbline 175
;      P6DIR   = 0x00;
	mov.b #0,&0x36
	.dbline 176
;      P6SEL   = 0x03;                  /* A/D-Wandler */
	mov.b #3,&0x37
	.dbline -2
	.dbline 177
;      }
L31:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e vTimeraInit _vTimeraInit fV
	.even
_vTimeraInit::
	.dbline -1
	.dbline 180
; 
; 
; void vTimeraInit( void ){
	.dbline 181
;      TACTL = TASSEL1 + TACLR;      /* SMCLK, clear TAR */
	mov #516,&0x160
	.dbline 182
;      CCTL0 = CCIE;                 /* CCR0 interrupt enable */
	mov #16,&0x162
	.dbline 183
;      CCR0 = 10000;                 /* 2,5 ms Timer Click */
	mov #10000,&0x172
	.dbline 184
;      TACTL |= MC0;                 /* Up-Mode */
	or #16,&0x160
	.dbline -2
	.dbline 185
;      }
L32:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e vInitDevices _vInitDevices fV
	.even
_vInitDevices::
	.dbline -1
	.dbline 189
; 
; 
; //call this routine to initialise all peripherals
; void vInitDevices( void ){
	.dbline 190
;      DINT();                       /* disable all interrupts */
	dint
	.dbline 198
; //   ME1     = 0x00;               /* disable sfr peripherals */
; //   ME2     = 0x00;               /* disable sfr peripherals */
; //   IE1     = 0x00;               /* disable sfr interrupts */
; //   IE2     = 0x00;               /* disable sfr interrupts */
; 
; //   WDTCTL  = 0x5A | 0x15;        /* watchdog initialisation including nmi function */
; 
;      vClockInit();                 /* initialise other peripherals */
	call #_vClockInit
	.dbline 199
;      vPortInit();
	call #_vPortInit
	.dbline -2
	.dbline 207
; //     vTimeraInit();			   /* erledigt UEXEC */
; 
; //   ME1     = 0xC0;               /* enable sfr peripherals */
; //   ME2     = 0x00;               /* enable sfr peripherals */
; //   IE1     = 0xC0;               /* enable sfr interrupts */
; //   IE2     = 0x03;               /* disable sfr interrupts */
; //   EINT();                       /* re-enable interrupts */
;      }
L33:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fI
	.even
_main::
	sub #4,R1
	.dbline -1
	.dbline 217
; 
; 
; 
; /***************************************************************************
; *    Main-Loop                                                             *
; *    - initialisiert Module und Variable                                   *
; *    - die stndig gerufenen Funktionen stehen in der Auftargsliste        *
; *
; ****************************************************************************/
; int main(void){
	.dbline 218
;      vInitDevices();
	call #_vInitDevices
	.dbline 219
;      wTaskId0 = UEXC_CreateTask(vTask0, &abTask0[0], sizeof (abTask0), 1);
	.dbline 220
;      wTaskId1 = UEXC_CreateTask(vTask1, &abTask1[0], sizeof (abTask1), 1);
	.dbline 221
;      UEXC_StartScheduler();
	mov #1,2(R1)
	mov #60,0(R1)
	mov #_abTask0,R15
	mov #_vTask0,R14
	call #_UEXC_CreateTask
	mov R14,r13
	mov r14,_wTaskId0
	mov #1,2(R1)
	mov #60,0(R1)
	mov #_abTask1,R15
	mov #_vTask1,R14
	call #_UEXC_CreateTask
	mov R14,r13
	mov r14,_wTaskId1
	call #_UEXC_StartScheduler
L35:
	.dbline 222
L36:
	.dbline 222
;      while (1);                         /* wird nie erreicht */
	jmp L35
X2:
	.dbline 223
;      return 1;                          /* unterdrckt Compilerwarnung */
	mov #1,R14
	.dbline -2
L34:
	add #4,R1
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(abs)
	.org 0xffec
	.word _timera_0_isr
	.area text
	.dbfile C:\projekte\msp430\ct04\ct04.c
	.dbfunc e timera_0_isr _timera_0_isr fV
	.even
_timera_0_isr::
	.dbline -1
	.dbline 232
;      }
; 
; /***************************************************************************
; * Kurzbeschreibung     : der Timer kontrolliert den zyklischen Aufruf
; *                        des Schedulers
; * Author               : Jens Altenburg
; ****************************************************************************/
; #pragma interrupt_handler timera_0_isr:TIMERA0_VECTOR
; void timera_0_isr(void){
	.dbline 233
;       CCR0 = 20000;                     /* 2,5 ms Takt */
	mov #20000,&0x172
	.dbline 234
; 	  P2OUT ^= 0x80;                    /* zum Taktmessen */
	xor.b #128,&0x29
	.dbline 235
; asm(
	 push  r4
	 push  r5
	 push  r6
	 push  r7
	 push  r8
	 push  r9
	 push  r10
	 push  r11
	 push  r12
	 push  r13
	 push  r14
	 push  r15
	 mov 	SP,_uexc_current_sp
	 call	#_UEXC_CheckTask
	 pop   r15
	 pop   r14
	 pop   r13
	 pop   r12
	 pop   r11
	 pop   r10
	 pop   r9
	 pop   r8
	 pop   r7
	 pop   r6
	 pop   r5
	 pop   r4
	 reti
	
	.dbline -2
	.dbline 263
; 	" push  r4\n"
; 	" push  r5\n"
; 	" push  r6\n"
; 	" push  r7\n"
; 	" push  r8\n"
; 	" push  r9\n"
; 	" push  r10\n"
; 	" push  r11\n"
; 	" push  r12\n"
; 	" push  r13\n"
; 	" push  r14\n"
; 	" push  r15\n"
; 	" mov 	SP,%uexc_current_sp\n" 		/* Stackpointer sichern */
;    	" call	#%UEXC_CheckTask\n"			/* Task-State prfen */
; 	" pop   r15\n"
; 	" pop   r14\n"
; 	" pop   r13\n"
; 	" pop   r12\n"
; 	" pop   r11\n"
; 	" pop   r10\n"
; 	" pop   r9\n"
; 	" pop   r8\n"
; 	" pop   r7\n"
; 	" pop   r6\n"
; 	" pop   r5\n"
; 	" pop   r4\n"
; 	" reti\n");
; 	}
L38:
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e UEXC_StartTimer _UEXC_StartTimer fV
	.even
_UEXC_StartTimer::
	.dbline -1
	.dbline 269
; 
; /***************************************************************************
; * Kurzbeschreibung     : "symbolischer" Timerstart
; * Author               : Jens Altenburg
; ****************************************************************************/
; void UEXC_StartTimer(void){
	.dbline 270
;      vTimeraInit();
	call #_vTimeraInit
	.dbline 271
;      EINT();	   /* Scheduler enables interrupts */
	eint
	.dbline -2
	.dbline 272
; 	 }
L39:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_SavregsAndResched _UEXC_SavregsAndResched fV
	.even
_UEXC_SavregsAndResched::
	.dbline -1
	.dbline 280
; 
; 
; /***************************************************************************
; * Kurzbeschreibung     : save state and then reschedule
; *                        this called by Defer to give up control
; * Author               : Jens Altenburg
; ****************************************************************************/
; void UEXC_SavregsAndResched(void){
	.dbline 281
; asm(
	 mov     SR,_wRegister
	 bis     #8,_wRegister
	 push.w  _wRegister
	 push  r4
	 push  r5
	 push  r6
	 push  r7
	 push  r8
	 push  r9
	 push  r10
	 push  r11
	 push  r12
	 push  r13
	 push  r14
	 push  r15
	 mov.w   r15,_wRegister
	 mov.w   _uexc_current_sp,r15
	 mov.w	  SP,(r15)
	 mov.w	  _wRegister,r15
	 br	  #_UEXC_Schedule
	
	.dbline -2
	.dbline 303
; 	" mov     SR,%wRegister\n"           /* interrupt stack frame */
; 	" bis     #8,%wRegister\n"		 	 /* enable GIE */
; 	" push.w  %wRegister\n"				 /* "SR" to stack */
; 	" push  r4\n"
; 	" push  r5\n"
; 	" push  r6\n"
; 	" push  r7\n"
; 	" push  r8\n"
; 	" push  r9\n"
; 	" push  r10\n"
; 	" push  r11\n"
; 	" push  r12\n"
; 	" push  r13\n"
; 	" push  r14\n"
; 	" push  r15\n"
; 	" mov.w   r15,%wRegister\n"			 /* r15 for indexed adressing */
; 	" mov.w   %uexc_current_sp,r15\n"
; 	" mov.w	  SP,(r15)\n"	 		 	 /* save stackpointer */
; 	" mov.w	  %wRegister,r15\n"
; 	" br	  #%UEXC_Schedule\n"		 /* Schedule */
; 	);
;     }
L40:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_StartNewTask _UEXC_StartNewTask fV
	.even
_UEXC_StartNewTask::
	.dbline -1
	.dbline 310
; 
; 
; /***************************************************************************
; * Kurzbeschreibung     : Start a New Task
; * Author               : Jens Altenburg
; ****************************************************************************/
; void UEXC_StartNewTask(void){
	.dbline 311
; asm(
	 mov     _uexc_current_sp, SP
	 push.w  #_UEXC_KillSelf
	 push.w  _uexc_current_func
	 mov	  SR,_wRegister
	 bis	  #8,_wRegister
	 push.w  _wRegister
	 reti
	
	.dbline -2
	.dbline 320
; 	" mov     %uexc_current_sp, SP\n"	 /* moves content of uexc_cu.. to SP */
; 	" push.w  #%UEXC_KillSelf\n" 		 /* Killself() onto stack */
; 	" push.w  %uexc_current_func\n"	 	 /* new function to stack */
; 	" mov	  SR,%wRegister\n"		 	 /* Statusregister bearbeiten */
; 	" bis	  #8,%wRegister\n"		 	 /* GIE */
; 	" push.w  %wRegister\n"			 	 /* statusregister to stack */
; 	" reti\n"						 	 /* go */
; 	);	 
;     }
L41:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e UEXC_Resume _UEXC_Resume fV
	.even
_UEXC_Resume::
	.dbline -1
	.dbline 328
; 
; /***************************************************************************
; * Kurzbeschreibung     : Resume a previously stopped task
; * Uebergabeparameter   :
; * Return Value         :
; * Author               : Jens Altenburg
; ****************************************************************************/
; void UEXC_Resume(void){
	.dbline 329
; asm(
	 mov     _uexc_current_sp, SP
	 pop   r15
	 pop   r14
	 pop   r13
	 pop   r12
	 pop   r11
	 pop   r10
	 pop   r9
	 pop   r8
	 pop   r7
	 pop   r6
	 pop   r5
	 pop   r4
	 reti
	
	.dbline -2
	.dbline 345
; 	" mov     %uexc_current_sp, SP\n"    /* Stackpointer setzen */
; 	" pop   r15\n"
; 	" pop   r14\n"
; 	" pop   r13\n"
; 	" pop   r12\n"
; 	" pop   r11\n"
; 	" pop   r10\n"
; 	" pop   r9\n"
; 	" pop   r8\n"
; 	" pop   r7\n"
; 	" pop   r6\n"
; 	" pop   r5\n"
; 	" pop   r4\n"
; 	" reti\n"				  		   	 /* ... */
; 	);
;     }
L42:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss
	.dbfile C:\projekte\msp430\ct04\ct04.c
_abTask2::
	.blkb 60
	.dbsym e abTask2 _abTask2 A[60:60]c
_abTask1::
	.blkb 60
	.dbsym e abTask1 _abTask1 A[60:60]c
_abTask0::
	.blkb 60
	.dbsym e abTask0 _abTask0 A[60:60]c
_bJA::
	.blkb 1
	.dbsym e bJA _bJA c
	.even
_w1::
	.blkb 2
	.dbsym e w1 _w1 i
	.even
_w0::
	.blkb 2
	.dbsym e w0 _w0 i
	.even
_wRegister::
	.blkb 2
	.dbsym e wRegister _wRegister i
	.even
_wTaskId2::
	.blkb 2
	.dbsym e wTaskId2 _wTaskId2 i
	.even
_wTaskId1::
	.blkb 2
	.dbsym e wTaskId1 _wTaskId1 i
	.even
_wTaskId0::
	.blkb 2
	.dbsym e wTaskId0 _wTaskId0 i
	.even
_stTimer::
	.blkb 2
	.dbsym e stTimer _stTimer X
	.area lit
	.even
	.area idata
	.even
	.area data
	.even
	.area bss
	.even
